commit b41b7954eba22fef557f91f5c2626defad9045bb
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Fri Jul 19 16:50:31 2024 +0530

    PS-9301 Non existent binlog cache means empty
    
    https://perconadev.atlassian.net/browse/PS-9301
    
    BUG#36252805 mysql/mysql-server@fed401689c2
    
    Problem:
    Checking if binlog cache is empty requires creating it first, then it
    will be empty. This causes sessions which never had or should not
    have binlog cache to get one, thus consuming unnecessary resources
    indefinitely.
    
    Analysis:
    It can be seen that binlog cache is created during for example rollback
    although the binlog cache does not exists and thus have no content.
    Several other places consider non existent binlog cache as empty.
    
    Solution:
    Change THD::is_binlog_cache_empty() to return true when binlog cache
    does not exist and remove calls to create the binlog cache before
    calling that function.
    
    Change-Id: I87e43dcff33a46790d0d29bc8259e38a1d1bd0ed

diff --git a/sql/binlog.cc b/sql/binlog.cc
index 4ad684724d0..014ffec37f4 100644
--- a/sql/binlog.cc
+++ b/sql/binlog.cc
@@ -10890,13 +10890,13 @@ bool THD::is_binlog_cache_empty(bool is_transactional)
   // If opt_bin_log==0, it is not safe to call thd_get_cache_mngr
   // because binlog_hton has not been completely set up.
   assert(opt_bin_log);
-  binlog_cache_mngr *cache_mngr= thd_get_cache_mngr(this);
-
-  // cache_mngr is NULL until we call thd->binlog_setup_trx_data, so
-  // we assert that this has been done.
-  assert(cache_mngr != NULL);
+  binlog_cache_mngr *const cache_mngr = thd_get_cache_mngr(this);
+  if (cache_mngr == NULL) {
+    // The cache has not been setup and is thus empty
+    DBUG_RETURN(true);
+  }
 
-  binlog_cache_data *cache_data=
+  binlog_cache_data *const cache_data=
     cache_mngr->get_binlog_cache_data(is_transactional);
   assert(cache_data != NULL);
 
diff --git a/sql/rpl_gtid_state.cc b/sql/rpl_gtid_state.cc
index bf9acd11dd1..bd89cc4e79e 100644
--- a/sql/rpl_gtid_state.cc
+++ b/sql/rpl_gtid_state.cc
@@ -1021,8 +1021,6 @@ void Gtid_state::update_gtids_impl_own_anonymous(THD* thd,
   */
   if (opt_bin_log)
   {
-    // Needed before is_binlog_cache_empty.
-    thd->binlog_setup_trx_data();
     if (!thd->is_binlog_cache_empty(true))
     {
       *more_trx= true;

